
;-----------------------------------====================*******/\/\/\******====================------------------------------------------

 .inesmap 0
 .inesmir 0
 .inesprg 2
 .ineschr 1

unit_space = $40

palette = 0
explosion_blink_flag = $20
explosion_blink_count = $21
frame_flag = $40
VRAM_palette = $41
sprite_cycler = $60
spr_ha_unit_countdown = $61
random = $80
new_rocket_chance = $90
unit_count = $A0
t0 = $F0
t1 = $F1
t2 = $F2
t3 = $F3
t4 = $F4
ju = $F8
jH = $F9
jL = $F8
jth_t0 = $FC
jth_t1 = $FD
jth_t2 = $FE
jth_t3 = $FF

unit_memory = $140
unit_flags =    unit_memory + (unit_space * 0)
unit_X =        unit_memory + (unit_space * 1)
unit_Y =        unit_memory + (unit_space * 2)
unit_tile =     unit_memory + (unit_space * 3)
unit_attr =     unit_memory + (unit_space * 4)
unit_mode =     unit_memory + (unit_space * 5)
unit_X_r =      unit_memory + (unit_space * 6)
unit_X_speedL = unit_memory + (unit_space * 7)
unit_X_speedH = unit_memory + (unit_space * 8)
unit_tilt =     unit_memory + (unit_space * 9)
unit_scrX =     unit_memory + (unit_space * 10)
unit_Y_r =      unit_memory + (unit_space * 11)
unit_Y_speedL = unit_memory + (unit_space * 12)
unit_Y_speedH = unit_memory + (unit_space * 13)
unit_time =     unit_memory + (unit_space * 14)
unit_decay = unit_tilt

sprite_dma_buffer = $700

;-----------------------------------====================*******/\/\/\******====================------------------------------------------

;types

;0: plain, 1-time
;1: 

 .bank 2
 .org $C000
 .incbin "firew.dmc"

 .bank 0
 .org $8000

int_reset:
	sei
	lda	#0
	sta	<frame_flag
	sta	$2000
	sta	$2001
	ldx	#4
.waitPPU1:
	lda	$2002
	bpl	.waitPPU1
.waitPPU2:
	lda	$2002
	bmi	.waitPPU2
	dex
	bne	.waitPPU1

	ldx	#$3F
	txs
reset_2:
	lda	#0
	tax
.cl_zp_mem:
	sta	$0,x
	dex
	bne	.cl_zp_mem

	ldy	#unit_space-1
	lda	#0
.clear_loop:
	sta	unit_flags,y
	dey
	bpl	.clear_loop

	ldx	$2002
	ldy	#8
	sty	<t0
	ldx	#$20
	stx	$2006
	sta	$2006
.nt_cl_2:
	tay
.nt_cl_1:
	sta	$2007
	dey
	bne	.nt_cl_1
	dec	<t0
	bne	.nt_cl_2

	ldy	#64
	ldx	#0
	lda	#$F8
.cl_spr:
	sta	sprite_dma_buffer,x
	inx
	inx
	inx
	inx
	dey
	bpl	.cl_spr
	lda	#0
	sta	$2003
	lda	#7
	sta	$4014

	lda	#%10010000
	sta	$2000
	lda	#%00011110
	sta	$2001

	ldy	#$F
.load_palette:
	lda	spr_palette,y
	sta	palette+$10,y
	lda	#$F
	sta	palette,y
	dey
	bpl	.load_palette
	inc	<VRAM_palette
	
	lda	#$88
	sta	random+0
	lda	#100
.random_init:
	pha
	jsr	randomize
	pla
	tax
	dex
	txa
	bne	.random_init
	jmp	done2
	
	lda	#$80
	sta	<new_rocket_chance

done:
	tsx
	lda	#low(done2)
	sta	$102,x
	lda	#high(done2)
	sta	$103,x
	rti
done2:
	lda	#1
	sta	<frame_flag
wait_nmi_jump:
	jmp	wait_nmi_jump

int_irq:
	rti
int_nmi:
	pha
	lda	<frame_flag
	ror	A
	pla
	bcs	.vblank
	rti
.vblank:
	dec	<frame_flag
	;update VRAM here
	lda	$2002
	lda	<VRAM_palette
	bne	.pal_update
	jmp	.no_pal_update
.pal_update:
	lda	#$3F
	sta	$2006
	ldy	#$00
	sty	$2006
	ldx	<palette+0
	stx	$2007
	lda	<palette+1
	sta	$2007
	lda	<palette+2
	sta	$2007
	lda	<palette+3
	sta	$2007
	stx	$2007
	lda	<palette+5
	sta	$2007
	lda	<palette+6
	sta	$2007
	lda	<palette+7
	sta	$2007
	stx	$2007
	lda	<palette+9
	sta	$2007
	lda	<palette+$A
	sta	$2007
	lda	<palette+$B
	sta	$2007
	stx	$2007
	lda	<palette+$D
	sta	$2007
	lda	<palette+$E
	sta	$2007
	lda	<palette+$F
	sta	$2007
	stx	$2007
	lda	<palette+$11
	sta	$2007
	lda	<palette+$12
	sta	$2007
	lda	<palette+$13
	sta	$2007
	stx	$2007
	lda	<palette+$15
	sta	$2007
	lda	<palette+$16
	sta	$2007
	lda	<palette+$17
	sta	$2007
	stx	$2007
	lda	<palette+$19
	sta	$2007
	lda	<palette+$1A
	sta	$2007
	lda	<palette+$1B
	sta	$2007
	stx	$2007
	lda	<palette+$1D
	sta	$2007
	lda	<palette+$1E
	sta	$2007
	lda	<palette+$1F
	sta	$2007
	sty	<VRAM_palette
.no_pal_update:
	lda	#0
	sta	$2003
	ldx	#7
	stx	$4014

	sta	$2006 ;?
	sta	$2006
	sta	$2005
	sta	$2005

;	inc	<frame_counter

engine:
	jsr	randomize
	
	;initialize rockets
	lda	<new_rocket_chance
	lsr	A
	lsr	A
	lsr	A
	lsr	A
	clc
	adc	#6
	sta	<t0
	lda	<random+0
	adc	<random+2
	adc	<random+5
	cmp	<t0
	bcc	.new
.l1:
	jsr	rocket_handler
	jsr	sprite_handler
	inc	<new_rocket_chance
	lda	<explosion_blink_count
	beq	.done_blink
	dec	<explosion_blink_count
	bne	.done_blink
	lda	#$F
	sta	<palette
	inc	<VRAM_palette
.done_blink:
	lda	<explosion_blink_flag
	beq	.no_blink_start
	lda	#0
	sta	<explosion_blink_flag
	lda	#3
	sta	<explosion_blink_count
	lda	#$30
	sta	<palette+0
	inc	<VRAM_palette
.no_blink_start:
	jmp	done

.new:
	lda	#0
	sta	<new_rocket_chance

	jsr	find_free
	bcs	.l1
	lda	unit_flags,y
	ora	#$80
	sta	unit_flags,y
	lda	#0
	sta	unit_mode,y
	jmp	.l1

rocket_handler:
	ldy	#0
.top:
	sty	<unit_count
	lda	unit_flags,y
	bpl	.next
	lda	#high(.return-1)
	pha
	lda	#low(.return-1)
	pha
	lda	unit_mode,y
	asl	A
	tax
	lda	mode_A+0,x
	sta	<jL
	lda	mode_A+1,x
	sta	<jH
	jmp	[ju]
.return:
	ldy	<unit_count
.next:
	iny
	cpy	#unit_space
	bmi	.top
	rts

mode_A:
	.dw rocket_begin ;0
	.dw rocket_shoot ;1
	.dw fragment1    ;2
	.dw explode      ;3

rocket_begin:
	;decide type of rocket

	
	;decide upwards movement speed
	lda	<random+4
	sta	unit_Y_speedL,y
	lda	<random+5
	and	#3
	clc
	adc	#2
	sta	unit_Y_speedH,y
	
	;decide forwards movement speed
	lda	<random+6
	lsr	A
	lsr	A
	lsr	A
	adc	<random+7
	sta	unit_X_speedL,y
	lda	#0
	rol	A
	sta	unit_X_speedH,y
	
	;decide gradual tilting and forwards movement direction
	lda	<random+1
	and	#$F
	sta	unit_tilt,y
	lda	<random+2
	and	#1
	ora	unit_flags,y
	sta	unit_flags,y
	
	;decide starting position
	lda	<random+3
	lsr	A
	clc
	adc	#$40
	sta	unit_X,y
	lda	#0
	sta	unit_scrX,y
	
	;decide time until explosion
	lda	<random+8
	lsr	A
	lsr	A
	lsr	A
	lsr	A
	clc
	adc	#$18
	sta	unit_time,y
	
	lda	#0
	sta	unit_attr,y
	sta	unit_tile,y

	;reset variables
	lda	#0
	sta	unit_Y_r,y
	sta	unit_X_r,y
	
	lda	#$DC
	sta	unit_Y,y
	
	lda	#1
	sta	unit_mode,y
	rts

rocket_shoot:

	lda	unit_Y_r,y
	sec
	sbc	unit_Y_speedL,y
	sta	unit_Y_r,y
	lda	unit_Y,y
	sbc	unit_Y_speedH,y
	sta	unit_Y,y
	bcs	.Y_ok
	jmp	unit_blank
.Y_ok:
	
	lda	unit_X_speedL,y
	clc
	adc	unit_tilt,y
	sta	unit_X_speedL,y
	lda	unit_X_speedH,y
	adc	#0
	sta	unit_X_speedH,y

	jsr	handle_X_move

	lda	unit_X_speedL,y
	sta	<t0
	ldx	unit_X_speedH,y
	lda	#$FF
	sta	<t1
	
.calc_tile:
	lda	<t0
	sec
	sbc	#$E0
	sta	<t0
	txa
	sbc	#0
	tax
	inc	<t1
	bcs	.calc_tile

	lda	<t1
	sta	unit_tile,y
	lda	unit_flags,y
	ror	A
	ror	A
	ror	A
	and	#$40
	sta	unit_attr,y
	
	lda	unit_time,y
	beq	explode
	ldx	unit_time,y
	dex
	txa
	sta	unit_time,y
	rts
;	lda	unit_Y,y
;	cmp	<random+1
;	bcc	.explode
;	rts

explode:
	;explosion

	lda	<random+0
	and	#3
	jsr	jumptable_handle
	.dw	explo1 ;8-way 1-color
	.dw	explo2 ;random no. fragment, random direction
	.dw	explo3 ;rose (16 units, 2-color)
	.dw	explo1

;8-way 1-color
explo1:
	jsr	explo_common

	;create 8 units
	jsr	unit_blank

	ldx	#7
.new_fragment:
	jsr	find_free
	bcs	.ex_done
	lda	#2
	sta	unit_mode,y
	lda	#$80
	sta	unit_flags,y

	txa
	stx	<t0
	asl	A
	asl	A
	asl	A
	asl	A
	asl	A
	clc
	adc	<random+2
	tax
	jsr	fragment_dispatch_common
	lda	<random+3
	and	#$10
	ora	#$40
	sta	unit_tile,y
	lda	<random+1
	and	#3
	sta	unit_attr,y
	
	lda	<random+4
	and	#3
	clc
	adc	#1
	;lda	#$3
	sta	unit_decay,y
	lda	<random+5
	and	#7
	clc
	adc	#$24
	;lda	#$2C
	sta	unit_time,y
	ldx	<t0
	dex
	bpl	.new_fragment
.ex_done:
	rts

explo2B:
	jsr	explo_common

	jsr	unit_blank

	tya
	and	#7
	tay
	lda	random+0,y
	and	#3
	jmp	explo2_C

explo2:
	jsr	explo_common

	jsr	unit_blank

	lda	<random+1
	and	#7
explo2_C:
	tax
.new_fragment:
	jsr	find_free
	bcs	.ex_done
	lda	#2
	sta	unit_mode,y
	lda	#$C0
	sta	unit_flags,y
	stx	<t0
	tya
	eor	<t0
	and	#7
	sta	<t4
	tax
	lda	<random+2,x
	tax
	jsr	fragment_dispatch_common
	tya
	tax
	asl	unit_Y_speedL,x
	rol	unit_Y_speedH,x
	asl	unit_X_speedL,x
	rol	unit_X_speedH,x
	lda	<random+3
	and	#$10
	ora	#$40
	sta	unit_tile,y
	lda	<random+1
	and	#3
	sta	unit_attr,y

	lda	<random+2
	and	#3
	clc
	adc	#$7
	;lda	#$9
	sta	unit_decay,y
	ldx	<t4
	lda	<random+1,x
	and	#7
	clc
	adc	#$20
	sta	unit_time,y
	ldx	<t0
	dex
	bpl	.new_fragment
.ex_done:
	rts

explo3: ;rose (16 units, 2-color)
	jsr	explo_common

	jsr	unit_blank

	ldx	#15
.new_fragment:
	jsr	find_free
	bcs	.ex_done
	lda	#2
	sta	unit_mode,y
	lda	#$80
	sta	unit_flags,y

	txa
	stx	<t0
	asl	A
	asl	A
	asl	A
	asl	A
	asl	A
	php
	bcc	.no_inner
	adc	#$F
.no_inner:
	clc
	adc	<random+2
	tax
	jsr	fragment_dispatch_common
	plp
	bcc	.no_inner_2
	tya
	tax
	lsr	unit_X_speedH,x
	ror	unit_X_speedL,x
	lsr	unit_Y_speedH,x
	ror	unit_Y_speedL,x
	lda	<random+4
	and	#$10
	ora	#$40
	sta	unit_tile,y
	lda	<random+3
	and	#3
	sta	unit_attr,y
	jmp	.done_shell
.no_inner_2:
	lda	<random+7
	and	#$10
	ora	#$40
	sta	unit_tile,y
	lda	<random+1
	and	#3
	sta	unit_attr,y
.done_shell:

	lda	<random+5
	and	#1
	clc
	adc	#1
	;lda	#$1
	sta	unit_decay,y
	lda	<random+6
	and	#7
	clc
	adc	#$30
;	lda	#$34
	sta	unit_time,y
	ldx	<t0
	dex
	bpl	.new_fragment
.ex_done:
	rts

	

explo_common:
	lda	#1
	sta	<explosion_blink_flag
	jsr	explode_sound

	lda	unit_X,y
	sta	<t1
	lda	unit_Y,y
	sta	<t2
	lda	unit_scrX,y
	sta	<t3
	rts

fragment_dispatch_common:
	lda	ydir,x
	asl	A
	ora	xdir,x
	ora	unit_flags,y
	sta	unit_flags,y
	lda	ydegree,x
	sta	unit_Y_speedL,y
	lda	xdegree,x
	sta	unit_X_speedL,y
	lda	#0
	sta	unit_Y_speedH,y
	sta	unit_X_speedH,y

	lda	<t1
	sta	unit_X,y
	lda	<t2
	sta	unit_Y,y
	lda	<t3
	sta	unit_scrX,y
	rts

fragment1:
	jsr	handle_X_move
	jsr	handle_Y_move

	lda	unit_X_speedL,y
	sec
	sbc	unit_decay,y
	sta	unit_X_speedL,y
	lda	unit_X_speedH,y
	sbc	#0
	sta	unit_X_speedH,y
	bcs	.X_spd_ok
	lda	#0
	sta	unit_X_speedH,y
	sta	unit_X_speedL,y
.X_spd_ok:
	lda	unit_Y_speedL,y
	sec
	sbc	unit_decay,y
	sta	unit_Y_speedL,y
	lda	unit_Y_speedH,y
	sbc	#0
	sta	unit_Y_speedH,y
	bcs	.Y_spd_ok
	lda	#0
	sta	unit_Y_speedH,y
	sta	unit_Y_speedL,y
.Y_spd_ok:
	lda	unit_time,y
	bne	.no_blank
	lda	unit_flags,y
	and	#$40
	beq	.no_refragment
	lda	<random+1
	cmp	#$40
	bcs	.no_refragment
	jmp	explo2B
.no_refragment:
	jmp	unit_blank
.no_blank:
	tax
	dex
	txa
	sta	unit_time,y

	cpx	#8
	bcs	.no_tile_change
	pha
	lda	unit_tile,y
	and	#$F0
	sta	<t0
	pla
	lsr	A
	lsr	A
	eor	#1
	clc
	adc	<t0
	sta	unit_tile,y
.no_tile_change:
	
	rts

handle_X_move:
	lda	unit_flags,y
	ror	A
	bcs	.X_left
	lda	unit_X_r,y
	adc	unit_X_speedL,y
	sta	unit_X_r,y
	lda	unit_X,y
	adc	unit_X_speedH,y
	sta	unit_X,y
	lda	unit_scrX,y
	adc	#0
	sta	unit_scrX,y
	jmp	.X_done
.X_left:
	lda	unit_X_r,y
	sbc	unit_X_speedL,y
	sta	unit_X_r,y
	lda	unit_X,y
	sbc	unit_X_speedH,y
	sta	unit_X,y
	lda	unit_scrX,y
	sbc	#0
	sta	unit_scrX,y
.X_done:
	rts

handle_Y_move:
	lda	unit_flags,y
	ror	A
	ror	A
	bcs	.Y_up
	lda	unit_Y_r,y
	adc	unit_Y_speedL,y
	sta	unit_Y_r,y
	lda	unit_Y,y
	adc	unit_Y_speedH,y
	sta	unit_Y,y
	bcc	.Y_done
	jmp	unit_blank
.Y_up:
	lda	unit_Y_r,y
	sbc	unit_Y_speedL,y
	sta	unit_Y_r,y
	lda	unit_Y,y
	sbc	unit_Y_speedH,y
	sta	unit_Y,y
	bcs	.Y_done
	jmp	unit_blank
.Y_done:
	rts

explode_sound:
	lda	#0
	sta	$4015
	lda	#$F
	sta	$4010
	lda	#0
	sta	$4011
	lda	#0
	sta	$4012
	lda	#$C0
	sta	$4013
	lda	#$10
	sta	$4015
	rts
	

unit_blank:
	lda	#0
	sta	unit_flags,y
	rts
	
find_free:
	ldy	#0
	clc
.loop:
	lda	unit_flags,y
	bpl	.found
	iny
	cpy	#unit_space
	bcc	.loop
.found:
	rts

unit_init:
	lda	#2
	sta	unit_mode,y
	lda	unit_flags,y
	ora	#$80
	sta	unit_flags,y
	rts

randomize:
	;random generator
	ldx	#0
	ldy	#$A
	lda	random+1,x
	eor	random+0,x
	lsr	A
	lsr	A
.random_l:
	ror	random+0,x
	inx
	dey
	bne	.random_l
	rts

sprite_handler:
	ldx	#0
	lda	#unit_space
	sta	<spr_ha_unit_countdown
	ldy	<sprite_cycler
.top:
	sty	<unit_count
	lda	unit_flags,y
	bpl	.next
	lda	unit_scrX,y
	bne	.next
	lda	unit_tile,y
	sta	sprite_dma_buffer+1,x
	lda	unit_attr,y
	sta	sprite_dma_buffer+2,x
	lda	unit_X,y
	sta	sprite_dma_buffer+3,x
	lda	unit_Y,y
	sta	sprite_dma_buffer+0,x
	inx
	inx
	inx
	inx
	sec
	beq	.sprite_overflow
.next:
	iny
	cpy	#unit_space
	bne	.no_wrap
	ldy	#0
.no_wrap:
	dec	<spr_ha_unit_countdown
	bne	.top
	clc
.sprite_overflow:
	php
	ldy	<sprite_cycler
	iny
	cpy	#unit_space
	bne	.no_cycler_wrap
	ldy	#0
.no_cycler_wrap:
	sty	<sprite_cycler
	plp
	bcs	.done_fill
	lda	#$F8
.fill_top:
	sta	sprite_dma_buffer+0,x
	inx
	inx
	inx
	inx
	bne	.fill_top
.done_fill:
	rts

jumptable_handle:
	stx	<jth_t2
	sty	<jth_t3
	asl	A
	tay
	iny
	pla
	sta	<jth_t0
	pla
	sta	<jth_t1
	lda	[jth_t0],y
	tax
	iny
	lda	[jth_t0],y
	sta	<jth_t1
	stx	<jth_t0
	ldx	<jth_t2
	ldy	<jth_t3
	jmp	[jth_t0]

spr_palette:
	.db $0F,$38,$27,$16,$0F,$24,$14,$25,$0F,$20,$10,$22,$0F,$2A,$1A,$21

xdegree:
	.incbin "xdegree.tbl"
xdir:
	.incbin "xdir.tbl"
ydegree:
	.incbin "ydegree.tbl"
ydir:
	.incbin "ydir.tbl"

 .bank 3
 .org $FFFA
 .dw int_nmi
 .dw int_reset
 .dw int_irq
 
 
 .bank 4
 .org $0000
 .incbin "2009.chr"
	
;-----------------------------------====================*******/\/\/\******====================------------------------------------------